<template>
  <b-col>
    <b-row>
      <b-col cols="2">
        <b-button v-b-toggle.region_collapse size="sm" variant="info">Filtro de zonas</b-button>
      </b-col>
      <b-col cols="10">
        <div>
          <b-form-tag
            v-for="(parent_region, index) in selected_parent_regions"
            @remove="removeParentRegionSelect(parent_region)"
            :key="index"
            variant="secondary"
            class="mr-1"
          >{{ parent_region.name }}</b-form-tag>
        </div>
        <div>
          <b-form-tag
            v-for="region in selected_regions"
            :key="region.pk"
            @remove="onRegionClick(region)"
            variant="primary"
            class="mr-1"
          >{{ region.postal_code }} - {{ region.name }}</b-form-tag>
        </div>
      </b-col>
    </b-row>
    <b-row>
      <b-col>
        <b-collapse id="region_collapse" class="mt-0 position-absolute bg-gradient-light">
          <RegionList
            @region-click="onRegionClick"
            @parent-region-click="onParentRegionClick"
          />
        </b-collapse>
      </b-col>
    </b-row>
    <b-row>
      <b-col>
        <b-aspect aspect="1.85:1" v-if="showMap">
          <l-map
            v-if="showMap"
            id="mainmap"
            ref="mainmap"
            :zoom.sync="zoom"
            :center.sync="center"
            :options="mapOptions"
            :bounds="bounds"
            @update:center="centerUpdate"
            @update:zoom="zoomUpdate"
          >
            <l-tile-layer :url="url" :attribution="attribution" />
            <l-geo-json
              v-for="(polygon, index) in regions_polygons"
              :key="index"
              :geojson="polygon.geom"
            ></l-geo-json>
          </l-map>
        </b-aspect>
      </b-col>
    </b-row>
  </b-col>
</template>

<script>
import L from "leaflet";
import { Icon } from "leaflet";
import { latLng } from "leaflet";
import { latLngBounds } from "leaflet";
import RegionList from "@/components/RegionList";

delete Icon.Default.prototype._getIconUrl;
Icon.Default.mergeOptions({
  iconRetinaUrl: require("leaflet/dist/images/marker-icon-2x.png"),
  iconUrl: require("leaflet/dist/images/marker-icon.png"),
  shadowUrl: require("leaflet/dist/images/marker-shadow.png")
});

import { LMap, LTileLayer, LGeoJson, LMarker, LTooltip } from "vue2-leaflet";
import "leaflet/dist/leaflet.css";

export default {
  name: "map-component",
  components: {
    RegionList,
    LMap,
    LTileLayer,
    LGeoJson
  },
  props: {},
  data() {
    return {
      zoom: 2,
      center: latLng(47.41322, -1.219482),
      url: "https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png",
      attribution: "&copy; CoronavirusMakers",
      withPopup: latLng(47.41322, -1.219482),
      withTooltip: latLng(47.41422, -1.250482),
      currentZoom: 2,
      currentCenter: latLng(47.41322, -1.219482),
      showParagraph: false,
      mapOptions: {
        zoomSnap: 1.5
      },
      bounds: latLngBounds([
        [35.946850084, -9.39288367353],
        [43.7483377142, 3.03948408368]
      ]),
      loading: false,
      isSavingShipping: false,
      showModalMap: false,
      markers: [],
      showMap: false,
      regions_polygons: [],
      selected_regions: [],
      selected_parent_regions: []
    };
  },
  computed: {},
  mounted() {
    this.showMap = true;
  },
  methods: {
    // Inserta o actualiza un polígono de región en el mapa
    upsertRegionPolygon(region) {
      if (!region.geom) {
        return;
      }
      let existent_polygon = this.regions_polygons.find(
        x => x.pk === region.pk
      );
      if (existent_polygon) {
        this.regions_polygons = this.regions_polygons.filter(
          region => region.pk !== existent_polygon.pk
        );
      } else {
        this.regions_polygons.push({
          pk: region.pk,
          name: region.name,
          postal_code: region.postal_code,
          geom: region.geom
        });
      }
    },
    // inserta o actualiza un punto en el mapa
    upsertMarker(middle, target) {
      if (!middle.point) {
        return;
      }
      let existent_polygon = this[target].find(x => x.pk === middle.pk);
      if (existent_polygon) {
        existent_polygon.name = middle.name;
        existent_polygon.point = middle.point;
      } else {
        this[target].push({
          pk: middle.pk,
          name: middle.name,
          point: middle.point
        });
      }
    },
    onParentRegionClick(data) {
      this.selected_parent_regions.push(data);
      this.$emit("onParentRegionAdded", {
        item: Object.assign({}, data),
        items: this.selected_parent_regions
      });
    },
    removeParentRegionSelect(data) {
      this.selected_parent_regions.splice(
        this.selected_parent_regions.indexOf(data),
        1
      );
      this.$emit("onParentRegionUnselected", {
        item: Object.assign({}, data),
        items: this.selected_parent_regions
      });
    },
    onRegionClick(data) {
      const isSelected = this.selected_regions.find(
        region => region.pk === data.pk
      );

      if (isSelected) {
        this.selected_regions = this.selected_regions.filter(
          region => region.pk !== data.pk
        );
      }
      if (!isSelected) {
        this.selected_regions = [...this.selected_regions, data];
        if (!data.geom) {
          return;
        }
        const bounds = L.geoJSON(data.geom).getBounds();
        this.$refs.mainmap.mapObject.fitBounds(bounds);
      }
      this.$emit("onRegionAdded", [...this.selected_regions]);

      this.upsertRegionPolygon(data);
    },
    zoomUpdate(zoom) {
      this.currentZoom = zoom;
    },
    centerUpdate(center) {
      this.currentCenter = center;
    }
  }
};
</script>

<style lang="scss" scoped>
.leaflet-control-attribution {
  display: none;
}
#region_collapse {
  z-index: 1070;
  background: rgba(250, 250, 250, 0.9);
}
</style>
